package com.emoon.knowledge.service.impl;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.knowledge.domain.MedicalRecordResult;
import com.emoon.knowledge.domain.bo.MedicalRecordResultBo;
import com.emoon.knowledge.domain.vo.MedicalRecordResultVo;
import com.emoon.knowledge.mapper.MedicalRecordResultMapper;
import com.emoon.knowledge.service.IMedicalRecordResultService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;


import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author wangkang
 * @date 2025-11-25
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class MedicalRecordResultServiceImpl implements IMedicalRecordResultService {

    private final MedicalRecordResultMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 主键
     * @return 【请填写功能名称】
     */
    @Override
    public MedicalRecordResultVo queryById(String id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询【请填写功能名称】列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 【请填写功能名称】分页列表
     */
    @Override
    public TableDataInfo<MedicalRecordResultVo> queryPageList(MedicalRecordResultBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<MedicalRecordResult> lqw = buildQueryWrapper(bo);
        Page<MedicalRecordResultVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的【请填写功能名称】列表
     *
     * @param bo 查询条件
     * @return 【请填写功能名称】列表
     */
    @Override
    public List<MedicalRecordResultVo> queryList(MedicalRecordResultBo bo) {
        LambdaQueryWrapper<MedicalRecordResult> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<MedicalRecordResult> buildQueryWrapper(MedicalRecordResultBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<MedicalRecordResult> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(MedicalRecordResult::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getPatientRecordId()), MedicalRecordResult::getPatientRecordId, bo.getPatientRecordId());
        lqw.eq(bo.getQcStartTime() != null, MedicalRecordResult::getQcStartTime, bo.getQcStartTime());
        lqw.eq(bo.getQcEndTime() != null, MedicalRecordResult::getQcEndTime, bo.getQcEndTime());
        lqw.eq(bo.getQcResult() != null, MedicalRecordResult::getQcResult, bo.getQcResult());
        lqw.eq(bo.getQcType() != null, MedicalRecordResult::getQcType, bo.getQcType());
        lqw.eq(StringUtils.isNotBlank(bo.getQcScore()), MedicalRecordResult::getQcScore, bo.getQcScore());
        lqw.eq(StringUtils.isNotBlank(bo.getQcComments()), MedicalRecordResult::getQcComments, bo.getQcComments());
        lqw.eq(StringUtils.isNotBlank(bo.getQcReviewComments()), MedicalRecordResult::getQcReviewComments, bo.getQcReviewComments());
        lqw.like(StringUtils.isNotBlank(bo.getQcName()), MedicalRecordResult::getQcName, bo.getQcName());
        lqw.eq(bo.getCreateDate() != null, MedicalRecordResult::getCreateDate, bo.getCreateDate());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), MedicalRecordResult::getStatus, bo.getStatus());
        lqw.eq(StringUtils.isNotBlank(bo.getDefFlag()), MedicalRecordResult::getDefFlag, bo.getDefFlag());
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(MedicalRecordResultBo bo) {
        MedicalRecordResult add = MapstructUtils.convert(bo, MedicalRecordResult.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(MedicalRecordResultBo bo) {
        MedicalRecordResult update = MapstructUtils.convert(bo, MedicalRecordResult.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(MedicalRecordResult entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除【请填写功能名称】信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
